﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        '
        Text = AppTitleAndVersion("Slot Viewer")
        ToolTips_Init()
        '
        Load_INI()
        InitParams()
        ' ----------------------------------------------------------------
        Timer1.Interval = 15
        Timer1.Start()
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- start UserInterface
        Refresh()
        Me.Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        Timer1.Stop()
        Save_INI()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then Return
        InitParams()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.WindowState <> FormWindowState.Minimized Then
            Timer1.Start()
        Else
            Timer1.Stop()
        End If
    End Sub


    ' ====================================================================================================
    '  Init SlotBars
    ' ====================================================================================================
    Private SlotBars(-1) As SlotBar
    Private Sub SlotBars_Show()
        If SlotBars Is Nothing OrElse NumSlots > SlotBars.Length Then
            Dim oldlen As Int32 = SlotBars.Length
            ReDim Preserve SlotBars(NumSlots - 1)
            For i As Int32 = oldlen To SlotBars.Length - 1
                SlotBars(i) = New SlotBar(Me)
            Next
        ElseIf NumSlots < SlotBars.Length Then
            For i As Int32 = NumSlots To SlotBars.Length - 1
                SlotBars(i).Destroy()
            Next
            ReDim Preserve SlotBars(NumSlots - 1)
        End If
        Dim barsLeft As Int32 = Panel_Controls.Right
        For i As Int32 = 0 To SlotBars.Length - 1
            SlotBars(i).SetSlotIndex(FirstSlot + i)
            If Vertical Then
                SlotBars(i).SetAspectParams(barsLeft + i * 22, 5, _
                                            22, _
                                            Me.ClientSize.Height - 9, _
                                            True, MaxValue, MinValue, Colors)
            Else
                SlotBars(i).SetAspectParams(barsLeft, 5 + i * 22, _
                                            Me.ClientSize.Width - barsLeft - 4, _
                                            22, _
                                            False, MaxValue, MinValue, Colors)
            End If
        Next
        For i As Int32 = 0 To SlotBars.Length - 1
            SlotBars(i).ShowValue()
        Next
    End Sub


    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private FirstSlot As Int32
    Private NumSlots As Int32
    Private MaxValue As Int32
    Private MinValue As Int32
    Friend Colors As Int32
    Private Vertical As Boolean
    Private RepeatDelay As Int32
    Private RepeatTime As Int32
    Private ClickEnabled As Boolean
    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.LostFocus, _
                                                                    txt_NumSlots.LostFocus, _
                                                                    txt_MaxValue.LostFocus, _
                                                                    txt_MinValue.LostFocus, _
                                                                    chk_Vertical.LostFocus
        Save_INI()
    End Sub
    Private Sub txt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles txt_FirstSlot.TextChanged, _
                                                                    txt_NumSlots.TextChanged, _
                                                                    txt_MaxValue.TextChanged, _
                                                                    txt_MinValue.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
    End Sub
    Private Sub chk_Colors_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Colors.ClickButtonArea
        Colors += 1
        If Colors > 2 Then Colors = 0
        InitParams()
        Save_INI()
        chk_Colors.Checked = False
    End Sub
    Private Sub chk_Vertical_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) _
                                                            Handles chk_Vertical.CheckedChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams(True)
    End Sub
    Private Sub InitParams(Optional ByVal minimize As Boolean = False)
        ' --------------------------------------------------------------------- set params
        SelectedSlotBar = Nothing
        FirstSlot = txt_FirstSlot.NumericValueInteger
        NumSlots = txt_NumSlots.NumericValueInteger
        txt_FirstSlot.MaxValue = 1000 - NumSlots
        txt_NumSlots.MaxValue = Math.Min(1000 - FirstSlot, 100)
        ' --------------------------------------------------------------------- 
        MaxValue = txt_MaxValue.NumericValueInteger
        MinValue = txt_MinValue.NumericValueInteger
        If MaxValue = MinValue Then
            MaxValue = MinValue + 1
            txt_MaxValue.NumericValueInteger = MaxValue
        End If
        Vertical = chk_Vertical.Checked
        ' --------------------------------------------------------------------- allow any resize
        Dim MinWidth As Int32 = Panel_Controls.Right + 210
        Dim MinHeight As Int32 = Panel_Controls.Bottom + SystemInformation.CaptionHeight + 20
        Me.MaximumSize = New Size(9000, 9000)
        Me.MinimumSize = New Size(MinWidth, MinHeight)
        ' --------------------------------------------------------------------- resze to minimum if changing direction
        If minimize Then Me.Size = New Size(MinWidth, MinHeight)
        ' --------------------------------------------------------------------- resize and limit the form
        EventsAreEnabled = False
        If Vertical Then
            Me.ClientSize = New Size(Panel_Controls.Right + 4 + NumSlots * 22, Me.ClientSize.Height)
            Me.MaximumSize = New Size(Me.Size.Width, 9000)
            Me.MinimumSize = New Size(Me.Size.Width, MinHeight)
        Else
            Me.ClientSize = New Size(Me.ClientSize.Width, 9 + NumSlots * 22)
            Me.MaximumSize = New Size(9000, Me.Size.Height)
            Me.MinimumSize = New Size(MinWidth + 2, Me.Size.Height)
        End If
        EventsAreEnabled = True
        ' --------------------------------------------------------------------- to overcome Linux position error
        If Not OperatingSystemIsWindows Then Panel_Controls.Left = -2
        ' --------------------------------------------------------------------- show
        SlotBars_Show()
        PanelDummy.SendToBack()
    End Sub

    ' ====================================================================================================
    '  Timer
    ' ====================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        PollSlots()
    End Sub
    Friend Sub PollSlots()
        For i As Int32 = 0 To SlotBars.Length - 1
            SlotBars(i).SetValue(Slots.ReadSlot(FirstSlot + i))
        Next
    End Sub


    ' ====================================================================================================
    '  ArrowUp / ArrowDown / Pageup / PageDown and MouseWheel 
    ' ====================================================================================================
    Friend SelectedSlotBar As SlotBar
    Friend Sub SetSelectedSlotBar(ByRef slotbar As SlotBar)
        SelectedSlotBar = slotbar
        PanelDummy.Focus()
    End Sub
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        Dim n As Single
        Select Case e.KeyCode
            Case Keys.Up, Keys.Right : n = 1
            Case Keys.Down, Keys.Left : n = -1
            Case Keys.PageUp : n = 10
            Case Keys.PageDown : n = -10
            Case Keys.Escape : SelectedSlotBar = Nothing
        End Select
        If e.Alt Then n *= 100
        If e.Shift Then n *= 10
        If e.Control Then n /= 10
        If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
    End Sub
    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        Dim n As Int32 = CInt(e.Delta / 1.2)
        If SelectedSlotBar IsNot Nothing Then SelectedSlotBar.DeltaValue(n)
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_FirstSlot, _
                        " First slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The index of the first slot." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

        ttp1.SetToolTip(txt_NumSlots, _
                        " Number of slots" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the consecutive slots." & vbCrLf & vbCrLf & _
                        " Press the left mouse button and move mouse Up and Down" & vbCrLf & _
                        " or use the mouse wheel to trim this value.")

    End Sub
    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_FirstSlot.MouseEnter, _
                                                                        txt_NumSlots.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


End Class